PROGRAM exampl1
!
!     THIS PROGRAM EXECUTES THE EXAMPLE PROBLEM ONE OF THE CONMIN MANUAL.

! Code converted using TO_F90 by Alan Miller
! Date: 2001-06-16  Time: 18:36:39

USE Constrained_minimization
USE common_cnmn1
IMPLICIT NONE
INTEGER, PARAMETER  :: dp = SELECTED_REAL_KIND(12, 60)

REAL (dp)  :: s(6), g1(11), g2(11), b(11,11), c(11), vlb(6), vub(6),  &
              scal(6), df(6), a(6,11)
INTEGER    :: ms1(22), isc(11), ic(11)

! COMMON /varable/ aobj, x(6), g(11)
REAL (dp)  :: aobj, x(6), g(11)

! COMMON /andata/ loopcnt

INTEGER    :: i, n1, n2, n3, n4, n5, nlim
REAL (dp)  :: phi

NAMELIST /conpar/ infog, info, nfdg, iprint, ndv, itmax, ncon,  &
    nside, icndir, nscal, fdch, fdchm, ct, ctmin, ctlmin, theta,  &
    phi, delfun, dabfun, linobj, itrm, x, vlb, vub, n1, n2, n3,  &
    n4, n5, alphax, abobj1, ctl, isc, scal
!
!
!  INITIALIZE
!
infog = 0
info = 0
nfdg = 0
iprint = 2
ndv = 4
itmax = 40
ncon = 3
nside = 0
icndir = 0
nscal = 0
fdch = 0.0
fdchm = 0.0
ct = 0.0
ctmin = 0.0
ctl = 0.0
ctlmin = 0.0
theta = 0.0
phi = 0.0
delfun = 0.0
dabfun = 0.0
linobj = 0.0
itrm = 0
n1 = 6
n2 = 11
n3 = 11
n4 = 11
n5 = 22
alphax = 0.0
abobj1 = 0.0
ctl = 0.0
DO  i = 1, ndv
  x(i) = 1.0_dp
  vlb(i) = -99999.0_dp
  vub(i) = 99999.0_dp
END DO
!
isc(1:ncon) = 0
!
!     READ THE PARAMETERS FOR CONMIN
!
!CC   READ(5,CONPAR)                  USE DEFAULT VALUES
WRITE (6,conpar)
nlim = itmax * (ndv+5)
!
!     NON-ITERATIVE PART OF ANALYSIS
!
igoto = 0
!
!     ITERATIVE PART OF ANALYSIS
!
DO  i = 1, nlim
!
!       CALL THE OPTIMIZATION ROUTINE CONMIN
!
  CALL conmin(x,vlb,vub,g,scal,df,a,s,g1,g2,b,c,isc,ic,ms1,n1,n2,n3,n4,n5)
!
!       ANALYSIS MODULE
!
  CALL analys()
  obj = aobj
  IF (igoto == 0) EXIT
END DO
!
!
STOP

CONTAINS



SUBROUTINE analys()
!
!   ROUTINE TO CALCULATE OBJECTIVE FUNCTION AND
!   CONSTRAINTS
!
!
!  OBJECTIVE FUNCTION
!
aobj = x(1) ** 2 - 5. * x(1) + x(2) ** 2 - 5. * x(2) + 2. * x(3) ** 2  &
       - 21. * x(3) + x(4) ** 2 + 7.0 * x(4) + 50.
!
!
!   CONSTRAINT VALUES
!
g(1) = x(1) ** 2 + x(1) + x(2) ** 2 - x(2) + x(3) ** 2 + x(3) +  &
       x(4) ** 2 - x(4) - 8.0
!
g(2) = x(1) ** 2 - x(1) + 2. * x(2) ** 2 + x(3) ** 2 + 2. * x(4) ** 2 &
     - x(4) - 10.0
!
g(3) = 2. * x(1) ** 2 + 2. * x(1) + x(2) ** 2 - x(2) + x(3) ** 2 - x(4) - 5.0
!
RETURN
END SUBROUTINE analys

END PROGRAM exampl1

