PROGRAM exampl2
!
!     THIS PROGRAM EXECUTES THE EXAMPLE PROBLEM TWO OF THE CONMIN MANUAL

! Code converted using TO_F90 by Alan Miller
! Date: 2001-06-16  Time: 18:36:44

USE Constrained_minimization
USE common_cnmn1
IMPLICIT NONE
INTEGER, PARAMETER  :: dp = SELECTED_REAL_KIND(12, 60)

REAL (dp)  :: s(6), g1(11), g2(11), b(11,11), c(11), vlb(6), vub(6),  &
              scal(6), df(6), a(6,11)
INTEGER    :: ms1(22), isc(11), ic(11)

! COMMON /varable/ aobj, x(6), g(11)
REAL (dp)  :: aobj, x(6), g(11)

! COMMON /andata/ loopcnt

! COMMON /grad/ isc(11), ic(11), df(6), a(6,11)

INTEGER    :: i, n1, n2, n3, n4, n5, nlim
REAL (dp)  :: phi

NAMELIST /conpar/ infog, info, nfdg, iprint, ndv, itmax, ncon,  &
    nside, icndir, nscal, fdch, fdchm, ct, ctmin, ctlmin, theta,  &
    phi, delfun, dabfun, linobj, itrm, x, vlb, vub, n1, n2, n3,  &
    n4, n5, alphax, abobj1, ctl, isc, scal

OPEN (UNIT=6,FILE='EXOUT2.TXT',STATUS='NEW')
!
!
!  INITIALIZE
!
infog = 0
info = 0
nfdg = 1
iprint = 1
ndv = 4
itmax = 40
ncon = 3
nside = 0
icndir = 0
nscal = 0
fdch = 0.0
fdchm = 0.0
ct = 0.0
ctmin = 0.0
ctl = 0.0
ctlmin = 0.0
theta = 0.0
phi = 0.0
delfun = 0.0
dabfun = 0.0
linobj = 0.0
itrm = 0
n1 = 6
n2 = 11
n3 = 11
n4 = 11
n5 = 22
alphax = 0.0
abobj1 = 0.0
ctl = 0.0
DO  i = 1, ndv
  x(i) = 1.0
  vlb(i) = -99999.
  vub(i) = 99999.
END DO
!
isc(1:ncon) = 0
!
!     READ THE PARAMETERS FOR CONMIN
!
!CC   READ(5,CONPAR)      USE DEFAULT VALUES
WRITE (6,conpar)
nlim = itmax * (ndv+5)
!
!     NON-ITERATIVE PART OF ANALYSIS
!
igoto = 0
!
!     ITERATIVE PART OF ANALYSIS
!
DO  i = 1, nlim
!
!       CALL THE OPTIMIZATION ROUTINE CONMIN
!
  CALL conmin(x,vlb,vub,g,scal,df,a,s,g1,g2,b,c,isc,ic,ms1,n1,n2,n3,n4,n5)
!
!
!       ANALYSIS MODULE
!
  CALL analys()
  obj = aobj
  IF (igoto == 0) EXIT
END DO
!
!
STOP


CONTAINS



SUBROUTINE analys()
!
!   ROUTINE TO CALCULATE OBJECTIVE FUNCTION AND CONSTRAINT VALUES
!   FOR OPTIMIZATION OF CONSTRAINED ROSEN-SUZUKI FUNCTION.
!
!
IF (info < 2) THEN
!
!  OBJECTIVE FUNCTION
!
  aobj = x(1) ** 2 - 5. * x(1) + x(2) ** 2 - 5. * x(2) + 2. *  &
         x(3) ** 2 - 21. * x(3) + x(4) ** 2 + 7.0 * x(4) + 50.
!
!
!   CONSTRAINT VALUES
!
  g(1) = x(1) ** 2 + x(1) + x(2) ** 2 - x(2) + x(3) ** 2 + x(3) +  &
         x(4) ** 2 - x(4) - 8.0
!
  g(2) = x(1) ** 2 - x(1) + 2. * x(2) ** 2 + x(3) ** 2 + 2. *  &
         x(4) ** 2 - x(4) - 10.0
!
  g(3) = 2. * x(1) ** 2 + 2. * x(1) + x(2) ** 2 - x(2) + x(3) ** 2  &
         - x(4) - 5.0
!
ELSE
!
!
!    GRADIENT INFORMATION
!
  df(1) = 2.0 * x(1) - 5.0
  df(2) = 2.0 * x(2) - 5.0
  df(3) = 4.0 * x(3) - 21.
  df(4) = 2.0 * x(4) + 7.
!
!  GRADIENTS OF ACTIVE AND VIOLATED CONSTRAINTS
!
  nac = 0
  IF (g(1) >= ct) THEN
    nac = 1
    ic(1) = 1
    a(1,1) = 2. * x(1) + 1.
    a(2,1) = 2. * x(2) - 1.
    a(3,1) = 2. * x(3) + 1.
    a(4,1) = 2. * x(4) - 1.
  END IF
!
  IF (g(2) >= ct) THEN
    nac = nac + 1
    ic(nac) = 2
    a(1,nac) = 2. * x(1) - 1.0
    a(2,nac) = 4. * x(2)
    a(3,nac) = 2. * x(3)
    a(4,nac) = 4. * x(4) - 1.0
  END IF
!
  IF (g(3) >= ct) THEN
    nac = nac + 1
    ic(nac) = 3
    a(1,nac) = 4. * x(1) + 2.
    a(2,nac) = 2. * x(2) - 1.
    a(3,nac) = 2. * x(3)
    a(4,nac) = -1.
  END IF
END IF
RETURN
END SUBROUTINE analys

END PROGRAM exampl2

